diff --git a/mysql-test/suite/funcs_1/r/processlist_priv_no_prot.result b/mysql-test/suite/funcs_1/r/processlist_priv_no_prot.result
index 6680e04..81aac7d 100644
--- a/mysql-test/suite/funcs_1/r/processlist_priv_no_prot.result
+++ b/mysql-test/suite/funcs_1/r/processlist_priv_no_prot.result
@@ -40,16 +40,19 @@ PROCESSLIST	CREATE TEMPORARY TABLE `PROCESSLIST` (
   `EXAMINED_ROWS` int(7) NOT NULL DEFAULT 0,
   `QUERY_ID` bigint(4) NOT NULL DEFAULT 0,
   `INFO_BINARY` blob DEFAULT NULL,
-  `TID` bigint(4) NOT NULL DEFAULT 0
+  `TID` bigint(4) NOT NULL DEFAULT 0,
+  `APPLICATION_NAME` varchar(64) DEFAULT NULL,
+  `CLIENT_USER` varchar(128) DEFAULT NULL,
+  `CLIENT_HOSTNAME` varchar(64) DEFAULT NULL
 )  DEFAULT CHARSET=utf8
 SHOW processlist;
 Id	User	Host	db	Command	Time	State	Info	Progress
 ID	root	HOST_NAME	information_schema	Query	TIME	init	SHOW processlist	TIME_MS
 ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS
 SELECT * FROM processlist  ORDER BY id;
-ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID
-ID	root	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM processlist  ORDER BY id	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM processlist  ORDER BY id	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
+ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID	APPLICATION_NAME	CLIENT_USER	CLIENT_HOSTNAME
+ID	root	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM processlist  ORDER BY id	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM processlist  ORDER BY id	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
 SELECT ID, USER, HOST, DB, COMMAND, TIME, STATE, INFO, TIME_MS, STAGE, MAX_STAGE, PROGRESS, MEMORY_USED, EXAMINED_ROWS, QUERY_ID, INFO_BINARY FROM processlist  ORDER BY id;
 ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY
 ID	root	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT ID, USER, HOST, DB, COMMAND, TIME, STATE, INFO, TIME_MS, STAGE, MAX_STAGE, PROGRESS, MEMORY_USED, EXAMINED_ROWS, QUERY_ID, INFO_BINARY FROM processlist  ORDER BY id	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT ID, USER, HOST, DB, COMMAND, TIME, STATE, INFO, TIME_MS, STAGE, MAX_STAGE, PROGRESS, MEMORY_USED, EXAMINED_ROWS, QUERY_ID, INFO_BINARY FROM processlist  ORDER BY id
@@ -119,14 +122,17 @@ PROCESSLIST	CREATE TEMPORARY TABLE `PROCESSLIST` (
   `EXAMINED_ROWS` int(7) NOT NULL DEFAULT 0,
   `QUERY_ID` bigint(4) NOT NULL DEFAULT 0,
   `INFO_BINARY` blob DEFAULT NULL,
-  `TID` bigint(4) NOT NULL DEFAULT 0
+  `TID` bigint(4) NOT NULL DEFAULT 0,
+  `APPLICATION_NAME` varchar(64) DEFAULT NULL,
+  `CLIENT_USER` varchar(128) DEFAULT NULL,
+  `CLIENT_HOSTNAME` varchar(64) DEFAULT NULL
 )  DEFAULT CHARSET=utf8
 SHOW processlist;
 Id	User	Host	db	Command	Time	State	Info	Progress
 ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	init	SHOW processlist	TIME_MS
 SELECT * FROM processlist  ORDER BY id;
-ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM processlist  ORDER BY id	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM processlist  ORDER BY id	TID
+ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID	APPLICATION_NAME	CLIENT_USER	CLIENT_HOSTNAME
+ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM processlist  ORDER BY id	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM processlist  ORDER BY id	TID	NULL	NULL	NULL
 SELECT ID, USER, HOST, DB, COMMAND, TIME, STATE, INFO, TIME_MS, STAGE, MAX_STAGE, PROGRESS, MEMORY_USED, EXAMINED_ROWS, QUERY_ID, INFO_BINARY FROM processlist  ORDER BY id;
 ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY
 ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT ID, USER, HOST, DB, COMMAND, TIME, STATE, INFO, TIME_MS, STAGE, MAX_STAGE, PROGRESS, MEMORY_USED, EXAMINED_ROWS, QUERY_ID, INFO_BINARY FROM processlist  ORDER BY id	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT ID, USER, HOST, DB, COMMAND, TIME, STATE, INFO, TIME_MS, STAGE, MAX_STAGE, PROGRESS, MEMORY_USED, EXAMINED_ROWS, QUERY_ID, INFO_BINARY FROM processlist  ORDER BY id
@@ -190,8 +196,8 @@ SHOW processlist;
 Id	User	Host	db	Command	Time	State	Info	Progress
 ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	init	SHOW processlist	TIME_MS
 SELECT * FROM information_schema.processlist;
-ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID
+ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID	APPLICATION_NAME	CLIENT_USER	CLIENT_HOSTNAME
+ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID	NULL	NULL	NULL
 ####################################################################################
 4.2 New connection con101 (ddicttestuser1 with PROCESS privilege)
 SHOW/SELECT shows all processes/threads.
@@ -206,10 +212,10 @@ ID	root	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS
 ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS
 ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	init	SHOW processlist	TIME_MS
 SELECT * FROM information_schema.processlist;
-ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	root	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
+ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID	APPLICATION_NAME	CLIENT_USER	CLIENT_HOSTNAME
+ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	root	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
 ####################################################################################
 5 Grant PROCESS privilege to anonymous user.
 connection default (user=root)
@@ -233,11 +239,11 @@ ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS
 ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS
 ID		HOST_NAME	information_schema	Query	TIME	init	SHOW processlist	TIME_MS
 SELECT * FROM information_schema.processlist;
-ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID
-ID		HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	root	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
+ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID	APPLICATION_NAME	CLIENT_USER	CLIENT_HOSTNAME
+ID		HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	root	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
 ####################################################################################
 6 Revoke PROCESS privilege from ddicttestuser1
 connection default (user=root)
@@ -259,10 +265,10 @@ ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS
 ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS
 ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	init	SHOW processlist	TIME_MS
 SELECT * FROM information_schema.processlist;
-ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
+ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID	APPLICATION_NAME	CLIENT_USER	CLIENT_HOSTNAME
+ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
 ####################################################################################
 7 Revoke PROCESS privilege from anonymous user
 connection default (user=root)
@@ -279,9 +285,9 @@ SHOW GRANTS FOR ''@'localhost';
 Grants for @localhost
 GRANT USAGE ON *.* TO ''@'localhost'
 SELECT * FROM information_schema.processlist;
-ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID
-ID		HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID
-ID		HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
+ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID	APPLICATION_NAME	CLIENT_USER	CLIENT_HOSTNAME
+ID		HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID	NULL	NULL	NULL
+ID		HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
 ####################################################################################
 8 Grant SUPER (does not imply PROCESS) privilege to ddicttestuser1
 connection default (user=root)
@@ -303,11 +309,11 @@ ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS
 ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS
 ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	init	SHOW processlist	TIME_MS
 SELECT * FROM information_schema.processlist;
-ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
+ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID	APPLICATION_NAME	CLIENT_USER	CLIENT_HOSTNAME
+ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
 ####################################################################################
 9 Revoke SUPER privilege from user ddicttestuser1
 connection default (user=root)
@@ -331,12 +337,12 @@ ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS
 ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS
 ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	init	SHOW processlist	TIME_MS
 SELECT * FROM information_schema.processlist;
-ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
+ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID	APPLICATION_NAME	CLIENT_USER	CLIENT_HOSTNAME
+ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
 ####################################################################################
 10 Grant SUPER privilege with grant option to user ddicttestuser1.
 connection default (user=root)
@@ -390,18 +396,18 @@ ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS
 ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS
 ID	ddicttestuser2	HOST_NAME	information_schema	Query	TIME	init	SHOW processlist	TIME_MS
 SELECT * FROM information_schema.processlist;
-ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID
-ID	ddicttestuser2	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID		HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID		HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	root	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
+ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID	APPLICATION_NAME	CLIENT_USER	CLIENT_HOSTNAME
+ID	ddicttestuser2	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID		HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID		HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	root	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
 ####################################################################################
 11 User ddicttestuser1 revokes PROCESS privilege from user ddicttestuser2
 connection ddicttestuser1;
@@ -421,9 +427,9 @@ Id	User	Host	db	Command	Time	State	Info	Progress
 ID	ddicttestuser2	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS
 ID	ddicttestuser2	HOST_NAME	information_schema	Query	TIME	init	SHOW processlist	TIME_MS
 SELECT * FROM information_schema.processlist;
-ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID
-ID	ddicttestuser2	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID
-ID	ddicttestuser2	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
+ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID	APPLICATION_NAME	CLIENT_USER	CLIENT_HOSTNAME
+ID	ddicttestuser2	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID	NULL	NULL	NULL
+ID	ddicttestuser2	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
 ####################################################################################
 11.2 Revoke SUPER,PROCESS,GRANT OPTION privilege from user ddicttestuser1
 connection default (user=root)
@@ -452,15 +458,15 @@ ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS
 ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS
 ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	init	SHOW processlist	TIME_MS
 SELECT * FROM information_schema.processlist;
-ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
+ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID	APPLICATION_NAME	CLIENT_USER	CLIENT_HOSTNAME
+ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
 ####################################################################################
 12 Revoke the SELECT privilege from user ddicttestuser1
 connection default (user=root)
@@ -490,16 +496,16 @@ ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS
 ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS
 ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	init	SHOW processlist	TIME_MS
 SELECT * FROM information_schema.processlist;
-ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
-ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID
+ID	USER	HOST	DB	COMMAND	TIME	STATE	INFO	TIME_MS	STAGE	MAX_STAGE	PROGRESS	MEMORY_USED	EXAMINED_ROWS	QUERY_ID	INFO_BINARY	TID	APPLICATION_NAME	CLIENT_USER	CLIENT_HOSTNAME
+ID	ddicttestuser1	HOST_NAME	information_schema	Query	TIME	Filling schema table	SELECT * FROM information_schema.processlist	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	SELECT * FROM information_schema.processlist	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
+ID	ddicttestuser1	HOST_NAME	information_schema	Sleep	TIME		NULL	TIME_MS	0	0	0.000	MEMORY	ROWS	QUERY_ID	NULL	TID	NULL	NULL	NULL
 ####################################################################################
 12.2 Revoke only the SELECT privilege on the information_schema from ddicttestuser1.
 connection default (user=root)
diff --git a/mysql-test/t/information_schema_processlist.test b/mysql-test/t/information_schema_processlist.test
new file mode 100644
index 0000000..d9341e6
--- /dev/null
+++ b/mysql-test/t/information_schema_processlist.test
@@ -0,0 +1,42 @@
+--echo #
+--echo # MDEV-????? Add fields Application_Name, Client_User et Client_Hostname
+--echo #            to information_schema.processlist
+--echo #            To set these columns, two ways :
+--echo #                via JDBC :
+--echo #                     cnx.setClientInfo("ApplicationName",value)
+--echo #                     cnx.setClientInfo("ClientUser",value)
+--echo #                     cnx.setClientInfo("ClientHostname",value)
+--echo #                via set session variables :
+--echo #                     set @ApplicationName=value (64 char max)
+--echo #                     set @ClientUser=value      (128 char max)
+--echo #                     set @ClientHostname=value  (64 char max)
+
+--let $con_id = `SELECT CONNECTION_ID()`
+--echo # Variables not set.
+--replace_result $con_id con_id
+eval select application_name, client_user, client_hostname from information_schema.processlist where id=$con_id;
+select count(*) from information_schema.processlist where application_name is null;
+
+--echo # All variables not set.
+set @ApplicationName='TestApp';
+set @ClientUser='Developper';
+set @ClientHostname='my PC';
+--replace_result $con_id con_id
+eval select application_name, client_user, client_hostname from information_schema.processlist where id=$con_id;
+select count(*) from information_schema.processlist where application_name is null;
+
+--echo # Reset variables to null
+set @ApplicationName=null;
+set @ClientUser=null;
+set @ClientHostname=null;
+--replace_result $con_id con_id
+eval select application_name, client_user, client_hostname from information_schema.processlist where id=$con_id;
+select count(*) from information_schema.processlist where application_name is null;
+
+--echo # Set value too long
+set @ApplicationName='aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa';
+set @ClientUser='aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa';
+set @ClientHostname='aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa';
+--replace_result $con_id con_id
+eval select application_name, client_user, client_hostname from information_schema.processlist where id=$con_id;
+eval select length(application_name), length(client_user), length(client_hostname) from information_schema.processlist where application_name is not null;
